#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include "sendto_.c"
#include <errno.h>

#define PORT 2222
#define BLOCKSIZE 128
#define WINDOWSIZE 4

/* Server prijima soubor */

typedef struct PACKET {
	unsigned char number;
	unsigned int size;
	char data[BLOCKSIZE];
} packet;

typedef struct RX_PACKET {
	unsigned char platnost;
	packet data;
} rx_packet;

typedef struct AKNOWLEDGE {
	unsigned char number;
	enum { DATA, END } type;
} acknowledge;

void print_packet(packet data){
	printf("Cislo: %u", data.number);
	
	return;
}

int main(int argc, char *argv[]){
	int sock;
	int fw;
	int status;
	struct sockaddr_in adresa;
	struct sockaddr_in adr_client;
	int adr_client_len = sizeof(adr_client);
	unsigned char i, j;
	acknowledge ack;
		
	int option = 1;
	rx_packet *window = (rx_packet *) malloc(WINDOWSIZE * sizeof(rx_packet));
	unsigned char zacatek = 0;
	packet temporary;
	
	memset(window, 0, WINDOWSIZE * sizeof(rx_packet));
	
	sock = socket(AF_INET, SOCK_DGRAM, 0);

	memset(&adresa, 0, sizeof(adresa));

	adresa.sin_port = htons(PORT);
	adresa.sin_family = AF_INET;
	adresa.sin_addr.s_addr = INADDR_ANY;

	setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &option, sizeof(option));
	
	if(bind(sock, (struct sockaddr *) &adresa, sizeof(adresa)) < 0){
		fprintf(stderr, "connect: %s\n", strerror(errno));
	}

	fw = open("RX_FILE.dat", O_CREAT|O_WRONLY|O_TRUNC, S_IRUSR|S_IWUSR);
	
	/* Prijem soubor */
	for(;;){
		status = recvfrom(sock, &temporary, sizeof(temporary), 0, (struct sockaddr *) &adr_client, (socklen_t *) &adr_client_len);
		if(status == -1){
			fprintf(stderr, "recvfrom: %s\n", strerror(errno));
			exit(-1);
		}
		if(temporary.number < zacatek || temporary.number > zacatek+4){
			/* odesli potvrzeni */
			ack.number = temporary.number;
			ack.type = DATA; 
	//		printf("SEND DATA ACK: %u\n", ack.number);
			sendto_(sock, &ack, sizeof(ack), 0, (struct sockaddr *) &adr_client, adr_client_len);	
		}
		else {
			/* uloz do okenka */
			window[(unsigned char)(temporary.number - zacatek)].data = temporary;		
			window[(unsigned char)(temporary.number - zacatek)].platnost = 1;
			for(i = 0; i < WINDOWSIZE; i++){
				if(window[i].platnost == 0)
					break;
				/* v i-1 bude hodnota posledniho packetu pro potvrzeni */
			}
			if(i){
				
				
				/* odesli potvrzeni packetu zacek + i - 1*/
				ack.number = zacatek + i - 1;
				ack.type = DATA;
				if(temporary.size != BLOCKSIZE){
					printf("Ukonceni!\n");
					sendto(sock, &ack, sizeof(ack), 0, (struct sockaddr *) &adr_client, adr_client_len);	

				}
				else {
				printf("SEND DATA ACK: %u\n", ack.number);
				sendto_(sock, &ack, sizeof(ack), 0, (struct sockaddr *) &adr_client, adr_client_len);	
				}
				/* Ulozeni dat na disk */
				for(j = 0; j < i; j++){
					write(fw, window[j].data.data, window[j].data.size);
				
					if(window[j].data.size != BLOCKSIZE){
						printf("Konec prenosu!\n");
						close(fw);
						close(sock);
						exit(0);
					}
					printf("Ukladam packet cislo %d.\n", window[j].data.number);
				}
				
				/* posun okna */	
				memmove(window, window + i, sizeof(rx_packet)*(WINDOWSIZE - i));
				memset(window + (WINDOWSIZE - i), 0, sizeof(rx_packet) * i);
				zacatek += i;
			}
		}
	}
	printf("Soubor uspesne prijat!\n");	
	return 0;	
}



